function b=ILDCT2(x,m);

% The function implements inverse local DCT2 transform
% x is the image, and must be square
% m is the local size, and must be dividor of size(x)

n=size(x,2);
C=kron(speye(n/m),idct(eye(m)));
b=C*x(1:n,1:n)*C';

Cnew=spalloc(n,n,m*n+3*m^2/2);
Cnew(1:3*m/2,1:3*m/2)=idct(eye(3*m/2));
Cnew(3*m/2+1:n-3*m/2,3*m/2+1:n-3*m/2)=kron(speye(n/m-3),idct(eye(m)));
Cnew(n-3*m/2+1:n,n-3*m/2+1:n)=idct(eye(3*m/2));

b=b+Cnew*x(n+1:2*n,1:n)*Cnew';
b=b/sqrt(2);