% Dictionary inpainting with TV regularization.
imname='barbara.png';
sigma=0; % sigma is the noise level contained in the image
maskname='text256.png';
iteration=1000;
tol=1e-4;
kappa=1;
%lambda=5e-4;
LWSize=16; % Window size of the local DCT.
LFSize=0; % local frequency in the local DCT.
ThreshType='s'; % Threshholding type, 's'oft or 'h'ard.

Level=1;  % The level of the framelet decomposition used.

m=3;
if m==1
    D{1}=[1 2 1]/4;
    D{2}=[1 0 -1]/4*sqrt(2);
    D{3}=[-1 2 -1]/4;
    D{4}='sss';
    R{1}=[1 2 1]/4;
    R{2}=[-1 0 1]/4*sqrt(2);
    R{3}=[-1 2 -1]/4;
    R{4}='sas';
elseif m==3
    D{1}=[1 4 6 4 1]/16;
    D{2}=[1 2 0 -2 -1]/8;
    D{3}=[-1 0 2 0 -1]/16*sqrt(6);
    D{4}=[-1 2 0 -2 1]/8;
    D{5}=[1 -4 6 -4 1]/16;
    D{6}='sssss';
    R{1}=[1 4 6 4 1]/16;
    R{2}=[-1 -2 0 2 1]/8;
    R{3}=[-1 0 2 0 -1]/16*sqrt(6);
    R{4}=[1 -2 0 2 -1]/8;
    R{5}=[1 -4 6 -4 1]/16;
    R{6}='sasas';
end


% for k=1:100
%     thr1(k)=(-9/99*k+10+9/99)*bthr1;
%     thr2(k)=(-9/99*k+10+9/99)*bthr2;
% end
%thr1(1:1000)=ones(1,1000)*bthr1;
%thr2(1:1000)=ones(1,1000)*bthr2;

im=double(imread(imname))/255;
noised_im=imnoise(im,'gaussian',0,sigma^2);
mask=1-(imread(maskname)>0.0001);
inpaint_im=mask.*noised_im;
[M,N]=size(im);

% eim=padarray(inpaint_im,[200,200],'symmetric','both');
% emask=padarray(mask,[200,200],'symmetric','both');
% [xm,ym]=find(emask);
% [xi,yi]=meshgrid([1:400+M],[1:400+N]);
% initial_f=griddata(xm,ym,eim(logical(emask)),xi,yi,'cubic');
% initial_f=initial_f(201:200+M,201:200+N)';

%initial_f=inpaint_im+(1-mask).*rand(size(im));
initial_f=zeros(size(im));

disp(['start iteration']);
iter=30;
fc=initial_f;  % component for framelet
fd=initial_f-fc;  % component for local dct
% stdnoise=sigma^2*m*n;

%===================================
nD=length(D);

thr1=1;aaa1=0.5;
thr2=200;aaa2=0.5;
lambda=0.001;aaa3=0.5;
thr22=thr2;
lambda2=lambda;

nfilter=1;
for ki=1:Level
    for ji=1:nD-1
        for jj=1:nD-1
            thl{ki}(ji,jj)=thr1*nfilter*norm(D{ji})*norm(D{jj});
        end
    end
    nfilter=nfilter*norm(D{1});
end
%===================================

for i=1:iteration
    
    nf=fc+fd;
    
    Rr=mask.*(inpaint_im-fc-fd);
    nfc=Rr+fc-lambda2*GradTV(fc);
    alphac=FraDecMultiLevel(nfc,D,Level);
    alphac=Thresh(alphac,thl);
    nnfc=FraRecMultiLevel(alphac,R,Level);
    ntol1=norm(fc-nnfc,'fro')/norm(inpaint_im);
    fc=nnfc;
    
    %Updating fd;
    Rr=mask.*(inpaint_im-fc-fd);
    nfd=Rr+fd;
    alphad=LDCT(nfd,LWSize,LFSize);
    tmp=wthresh(alphad,ThreshType,thr22);
    alphad=tmp;
    nnfd=ILDCT2(alphad,LWSize);
    ntol2=norm(fd-nnfd,'fro')/norm(inpaint_im);
    fd=nnfd;
    
    f=fc+fd;
    ntol=norm(f-nf,'fro')/norm(inpaint_im,'fro');
    psnrf(i)=psnr(f,im);
    disp(['Iteration: ' num2str(i) ', Tol: ' num2str(ntol) ', Tol1: ' num2str(ntol1)...
        ', Tol2: ' num2str(ntol2) ', PSNR: ' num2str(psnrf(i))]);
    %figure(1),subplot(1,2,1),imshow(kron(fc,ones(3))),axis equal;
    %subplot(1,2,2),imshow(kron(fd+0.5,ones(3))),axis equal;
    
    %Adjust thresholding parameters
    %=================================================================
    if (ntol<=tol) 
        aaa1=aaa1*0.9;
        if aaa1<1e-4
            break;
        end
        nfilter=1;nD=length(D);
        for ki=1:Level
            for ji=1:nD-1
                for jj=1:nD-1
                    thl{ki}(ji,jj)=aaa1*thr1*nfilter*norm(D{ji})*norm(D{jj});
                end
            end
            nfilter=nfilter*norm(D{1});
        end
        aaa2=aaa2*0.9;thr22=aaa2*thr2;
        aaa3=aaa3*0.9;lambda2=lambda*aaa3;
    end
    %==================================================================
end
    
figure,imshow(nnfc+nnfd);
psnr(nnfc+nnfd,im)