function Rec=FraRec(C,R,L)

% function Rec=FraRec(C,R,L)
% This function implement framelet reconstruction.
% C ==== the data to be reconstructed, which are in cells in C{i,j} with
% C{1,1} being a cell.
% R ==== is the reconstruction filter in 1D. In 2D, it is generated by tensor
% product. The filter D must be symmetric or anti-symmetric, which
% are indicated by 's' and 'a' respectively in the last cell of R.
% L ==== is the level of the decomposition.
% Rec ==== is the reconstructed data.

% Written by Jian-Feng Cai.
% email: jfcai@math.cuhk.edu.hk

nR=length(R);
SorAS=R{nR};

Rec=zeros(size(C{2,2}));

for i=1:nR-1
    M1=R{i};
    for j=1:nR-1
        M2=R{j};
        temp=ConvSymAsym(C{i,j},M1,SorAS(i),L);
        temp=ConvSymAsym(temp',M2,SorAS(j),L);
        Rec=Rec+temp';
    end
end